<?php

/* Address Add -- allows you to add the From address to the address book.  */

function squirrelmail_plugin_init_address_add() {
  global $squirrelmail_plugin_hooks;
  
  $squirrelmail_plugin_hooks['read_body_after_from']['address_add'] = 'address_add_read';
}




function address_add_read_string($str) {
  sqextractGlobalVar('address_found_email');
  global $address_found_email;

  $IP_RegExp_Match = '\\[?[0-9]{1,3}(\\.[0-9]{1,3}){3}\\]?';
  $Host_RegExp_Match = '(' . $IP_RegExp_Match . '|[0-9a-z]([-.]?[0-9a-z])*\\.[a-z][a-z]+)';
  $Email_RegExp_Match = '[0-9a-z]([-_.+|]?[_0-9a-z|])*(%' . $Host_RegExp_Match . ')?@' . $Host_RegExp_Match;

  while (eregi('(' . $Email_RegExp_Match . ')', $str, $hits)) {
      $str = substr(strstr($str, $hits[0]), strlen($hits[0]));
      if (! isset($address_found_email[$hits[0]])) {
	  $address_found_email[$hits[0]] = 1;
	  return $hits[0];
      }
  }
  return;
}


function address_add_read_array($array) {
  $i = 0;
  while ($i < count($array)) {
    address_add_read_string($array[$i]);
    $i ++;
  }
}


function address_add_read() {
  global $color, $message, $imapConnection;

   if(!$message->header->from){ 
      $decodedfrom = decodeHeader($message->rfc822_header->getAddr_s('from'));
   } else {
      $decodedfrom = decodeHeader($message->header->from);
   }

  $froms = address_add_read_string($decodedfrom);

   include_once ('../functions/addressbook.php');

   // Open addressbook without error messages and without LDAP
   $abook = addressbook_init(false, true);
      // No personal address book is defined
   if ($abook->localbackend == 0)
      return;

   $alist = $abook->list_addr();
   if (! is_array($alist))
      // Some sort of error
      return;
   
   // Emails
   foreach ($alist as $val) {
      if ($froms == $val['email'])
	return;
   }

   $atpos = strpos($froms, "@");
   $nick = substr($froms, 0, $atpos);

   $spacepos = strpos($decodedfrom, " ");
   $spacepos2 = strpos($decodedfrom, " ", $spacepos+1);
   $qoutepos = strpos($decodedfrom, chr(34),1);
   $bracketpos = strpos($decodedfrom, "<",0);
   if (!is_integer($bracketpos))
      $bracketpos = strpos($decodedfrom, "(",0);

   if ($spacepos2 > $bracketpos)
	$spacepos2 = -1;

   if (is_integer($spacepos) && !is_integer($qoutepos))
      $first = ucfirst(substr($decodedfrom, 0, $spacepos));

   if (is_integer($spacepos) && is_integer($qoutepos))
      $first = ucfirst(substr($decodedfrom, 1, $spacepos-1));

   if (is_integer($spacepos) && is_integer($qoutepos) && $qoutepos < $spacepos)
      $first = ucfirst(substr($decodedfrom, 1, $qoutepos-1));

   if (!is_integer($spacepos) && !is_integer($qoutepos))
      $first = "";

   if (is_integer($qoutepos) && $qoutepos > $spacepos)
      $last = ucfirst(substr($decodedfrom, $spacepos+1, ($qoutepos-$spacepos)-1));

   if (!is_integer($qoutepos) && is_integer($spacepos))
      $last = ucfirst(substr($decodedfrom, $spacepos+1, ($spacepos2-$spacepos)-1));

   if ($spacepos == $bracketpos - 1)
      $last = "";
   if ($froms != "") 
      $froms = urlencode(urlencode($froms));
   if ($nick != "")
      $nick = urlencode(urlencode($nick));
   if ($first != "")
      $first = urlencode(urlencode($first));
   if ($last != "")
      $last = urlencode(urlencode($last));

  echo  "<SMALL><A HREF='../plugins/address_add/add.php?email=$froms&nick=$nick&first=$first&last=$last'>";
  echo _("Add");
  echo "</a></SMALL>";
}

?>
